#include <stdio.h>

typedef union {
     float f;
     struct {
          unsigned mantissa : 23;
          unsigned exponent : 8;
          unsigned sign : 1;
     } parts;
} myfloat;

unsigned int mantissa(float f)
{
     unsigned *uf = (unsigned *) &f;
     *uf <<= 9;
     *uf >>= 9;
     return *uf;
}

unsigned int mantissa2(float f)
{
     unsigned *uf = (unsigned *) &f;
     unsigned filter = 0xffffffff; // UINT_MAX
     *uf &= filter >> 9;
     return *uf;
}

unsigned int exponent(float f)
{
     unsigned *uf = (unsigned *) &f;
     // Remove sign
     *uf <<= 1;
     *uf >>= 1;
     // Remove mantissa
     *uf >>= 23;
     return *uf;
}

int main(void)
{
     myfloat f;
     scanf("%f", &f.f);
     printf("mantissa : %u\n", mantissa(f.f));
     printf("mantissa2 : %u\n", mantissa2(f.f));
     printf("exponent : %u\n", exponent(f.f));
     printf("correct mantissa : %u\n", f.parts.mantissa);
     printf("correct exponent : %u\n", f.parts.exponent);
     return 0;
}
